/*
---
description: Animation package

license: MIT-style

authors: Olivier Gasc (gasc.olivier@gmail.com)

requires:
- Events
- Element
- Element.Dimensions
- Array
- Function
- Options

provides: [AnimationManager, AnimationStatic, AnimationCanvas, AnimationAnimated]
...
*/

window.requestAnimFrame=function(){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(e){window.setTimeout(e,1e3/60)}}();AnimationManager=new Class({LAYER_DEFAULT:100,time:{delta:0,old:0},running:false,canvas:null,ctx:null,layers:[],debug:false,ratio:1,currentlyOver:null,initialize:function(e){this.canvas=document.id(e);this.ctx=document.getElementById(e).getContext("2d");this.play();this.canvas.addEvents({click:function(e){var t=this.canvas.getPosition(),n=window.getScroll();x=n.x+e.client.x/this.ratio-t.x,y=n.y+e.client.y/this.ratio-t.y,a=[];e:for(var r=this.layers.length-1;r>=0;r--){if(this.layers[r]!==undefined){a=this.layers[r];for(var i=a.length-1;i>=0;i--){if(a[i]!==undefined&&a[i].options.onClicked){if(x>=a[i].x+a[i].options.offset.x&&x<=a[i].x+a[i].options.offset.x+a[i].getFrameSize().x&&y>=a[i].y+a[i].options.offset.y&&y<=a[i].y+a[i].options.offset.y+a[i].getFrameSize().y){a[i].options.onClicked.attempt([a[i],{x:x,y:y}],this);break e}}}}}}.bind(this),mousemove:function(e){var t=this.canvas.getPosition(),n=window.getScroll();x=n.x+e.client.x/this.ratio-t.x,y=n.y+e.client.y/this.ratio-t.y,a=[],lastOver=this.currentlyOver;this.currentlyOver=null;e:{for(var r=this.layers.length-1;r>=0;r--){if(this.layers[r]!==undefined){a=this.layers[r];for(var i=a.length-1;i>=0;i--){if(a[i]!==undefined&&a[i].options.onEnter){if(x>=a[i].x+a[i].options.offset.x&&x<=a[i].x+a[i].options.offset.x+a[i].getFrameSize().x&&y>=a[i].y+a[i].options.offset.y&&y<=a[i].y+a[i].options.offset.y+a[i].getFrameSize().y){this.currentlyOver=a[i];if(this.currentlyOver!==lastOver){a[i].options.onEnter.attempt([a[i],{x:x,y:y}],this)}break e}}}}}if(!this.currentlyOver&&lastOver&&lastOver.options.onLeave){lastOver.options.onLeave.attempt([lastOver],this)}}}.bind(this)});return this},play:function(){this.running=true;this.time.old=+(new Date);this.run();return this},stop:function(){this.running=false;return this},run:function(){if(this.running){requestAnimFrame(this.run.bind(this));this.clear();this.render();var e=+(new Date);this.time.delta=e-this.time.old;this.time.old=e}return this},render:function(e){this.layers.each(function(e,t){e.sort(function(e,t){if(e.y+e.height/e.options.cases.y>t.y+t.height/t.options.cases.y)return 1;if(e.y+e.height/e.options.cases.y<t.y+t.height/t.options.cases.y)return-1;return 0});e.each(function(e){if(e.loaded&&e.shown&&e.draw!==undefined)e.draw.attempt([],e)})});return this},clear:function(){this.ctx.clearRect(0,0,this.canvas.getSize().x,this.canvas.getSize().y);return this},empty:function(e){if(e){if(this.layers[this.LAYER_DEFAULT+e]!==undefined)this.layers.splice(this.LAYER_DEFAULT+e)}else{this.layers=[]}return this},add:function(e){if(this.layers[e.layer]===undefined)this.layers[e.layer]=[];this.layers[e.layer].push(e);return e},remove:function(e){if(e.animations!==undefined){for(var t in e.animations){this.remove(e.animations[t])}}else{e.hide();if(this.layers[e.layer]!==undefined){for(var t=this.layers[e.layer].length-1;t>=0;t--){if(this.layers[e.layer][t]&&this.layers[e.layer][t].referer.id===e.referer.id){this.layers[e.layer].splice(t,1);break}}if(this.layers[e.layer].length===0)this.layers.splice(e.layer,1)}}return this}});AnimationStatic=new Class({Implements:Options,manager:null,referer:null,buffer:{},width:0,height:0,x:0,y:0,layer:null,shown:false,loaded:false,options:{image:null,start:{x:0,y:0},cases:{x:1,y:1},offset:{x:0,y:0},layer:0,onLoad:function(){},onBeforeDraw:function(){},onHide:function(){},onShow:function(){},onClicked:null,onEnter:null},initialize:function(e,t,n){if(!e)return this;this.setOptions(t);if(n!==undefined)this.referer=n;this.manager=e;this.x=this.options.start.x;this.y=this.options.start.y;this.layer=e.LAYER_DEFAULT+this.options.layer;if(this.options.image)this.onLoad(this.options.image);return this},onLoad:function(e){this.width=+this.options.image.width;this.height=+this.options.image.height;this.loaded=true;this.options.onLoad.attempt([],this)},draw:function(){this.options.onBeforeDraw.attempt([],this);if(this.manager.debug){this.manager.ctx.fillStyle="rgba(200, 0, 0, .4)";this.manager.ctx.fillRect((this.options.offset.x+this.x)*this.manager.ratio,(this.options.offset.y+this.y)*this.manager.ratio,this.getFrameSize(true).x,this.getFrameSize(true).y)}this.manager.ctx.drawImage(this.options.image,0,0,this.width/this.options.cases.x,this.height/this.options.cases.y,(this.options.offset.x+this.x)*this.manager.ratio,(this.options.offset.y+this.y)*this.manager.ratio,this.getFrameSize(true).x,this.getFrameSize(true).y)},hide:function(){if(this.loaded&&this.shown){this.shown=false;this.options.onHide.attempt([],this)}return this},show:function(){if(this.loaded&&!this.shown){this.shown=true;this.options.onShow.attempt([],this)}return this},getRefererType:function(){return typeOf(this.referer)==="object"?instanceOf(this.referer):this.referer},getFrameSize:function(e){return{x:this.width/this.options.cases.x*(e?this.manager.ratio:1),y:this.height/this.options.cases.y*(e?this.manager.ratio:1)}},getCenter:function(e){return{x:this.getFrameSize(e).x/2,y:this.getFrameSize(e).y/2}}});AnimationCanvas=new Class({Extends:AnimationStatic,options:{canvas:null,start:{x:0,y:0},cases:{x:1,y:1},offset:{x:0,y:0},layer:0,onLoad:function(){},onBeforeDraw:function(){},onHide:function(){},onShow:function(){},onClicked:null,onEnter:null,onLeave:null},initialize:function(e,t,n){this.setOptions(t);if(n!==undefined)this.referer=n;this.manager=e;this.x=this.options.start.x;this.y=this.options.start.y;this.layer=e.LAYER_DEFAULT+this.options.layer;if(this.options.canvas)this.onLoad(this.options.canvas);return this},onLoad:function(e){this.width=+this.options.canvas.width;this.height=+this.options.canvas.height;this.loaded=true;this.options.onLoad.attempt([],this)},draw:function(){this.options.onBeforeDraw.attempt([],this);if(this.manager.debug){this.manager.ctx.fillStyle="rgba(200, 0, 0, .4)";this.manager.ctx.fillRect((this.options.offset.x+this.x)*this.manager.ratio,(this.options.offset.y+this.y)*this.manager.ratio,this.getFrameSize(true).x,this.getFrameSize(true).y)}this.manager.ctx.drawImage(this.options.canvas,0,0,this.width/this.options.cases.x,this.height/this.options.cases.y,(this.options.offset.x+this.x)*this.manager.ratio,(this.options.offset.y+this.y)*this.manager.ratio,this.getFrameSize(true).x,this.getFrameSize(true).y)}});AnimationAnimated=new Class({Extends:AnimationStatic,MOVE_BOTTOM:0,MOVE_LEFT:1,MOVE_RIGHT:2,MOVE_TOP:3,timeLeft:null,pxLeft:null,currentFrame:0,column:0,periodical:null,options:{image:null,start:{x:0,y:0},cases:{x:1,y:1},offset:{x:0,y:0},layer:0,step:100,line:0,order:1,autorun:false,onLoad:function(){},onBeforeDraw:function(){},onAfterDraw:function(){},onHide:function(){},onShow:function(){},onClicked:null,onEnter:null,onLeave:null},initialize:function(e,t,n){this.setOptions(t);if(n!==undefined)this.referer=n;this.manager=e;this.x=this.options.start.x;this.y=this.options.start.y;this.layer=e.LAYER_DEFAULT+this.options.layer;if(this.options.image){this.onLoad(this.options.image);if(this.options.autorun&&this.options.step)this.start()}return this},draw:function(){this.options.onBeforeDraw.attempt([this.timeLeft],this);if(this.manager.debug){this.manager.ctx.fillStyle="rgba(200, 0, 0, .4)";this.manager.ctx.fillRect((this.options.offset.x+this.x)*this.manager.ratio,(this.options.offset.y+this.y)*this.manager.ratio,this.getFrameSize(true).x,this.getFrameSize(true).y)}this.manager.ctx.drawImage(this.options.image,this.column*this.width/this.options.cases.x,this.options.line*this.height/this.options.cases.y,this.width/this.options.cases.x,this.height/this.options.cases.y,(this.options.offset.x+this.x)*this.manager.ratio,(this.options.offset.y+this.y)*this.manager.ratio,this.getFrameSize(true).x,this.getFrameSize(true).y);this.options.onAfterDraw.attempt([],this)},stop:function(){if(this.periodical&&!this.options.autorun){clearInterval(this.periodical);this.periodical=null}},start:function(){if(!this.periodical){this.periodical=setInterval(function(){this.column=this.column<this.options.cases.x-1?this.column+1:0;this.currentFrame=this.currentFrame<this.options.cases.x?this.currentFrame++:0}.bind(this),this.options.step)}}})